function[out,out2,out3,out4,out5,out6,out7]= sgdPhysics_v3(plotRate, stepSizeChoice, estimatorChoice, nIter, userBatch, nOfExperiments, nUser, xi0, nu0,FCStr,UserStr, dispMessage,detThresholdParam)

Omega_USER = [UserStr(1) 1-UserStr(1) 0 0; UserStr(2) 1-UserStr(2) 0 0; 0 0 UserStr(3) 1-UserStr(3); 0 0 UserStr(4) 1-UserStr(4)];
Omega_FC = [FCStr(1) 0 1-FCStr(1) 0; 0 FCStr(2) 0 1-FCStr(2); FCStr(3) 0 1-FCStr(3) 0; 0 FCStr(4) 0 1-FCStr(4)];
Omega = Omega_USER*Omega_FC;
l0 = 100; tau0 = .05; % Step Size
emptyList = zeros(nIter/plotRate,1);
averageTrueUserCooperationRate = zeros(nIter/plotRate,1);
expectedUserCooperationRate = zeros(nIter/plotRate,1);
PhiVector = zeros(nIter/plotRate,1);
mNormVector = zeros(nIter/plotRate,1);
rewardVector = zeros(nIter/plotRate,1);
userPayoff = zeros(nIter/plotRate,1);
truePositiveRate = zeros(nIter/plotRate,1);
falsePositiveRate = zeros(nIter/plotRate,1);

% SVD Mod:
svd_samples = zeros(nIter/plotRate,46);
for experiment = 1:nOfExperiments
    
    % Initial State Distribution
    lambda = [1 0 0 0];
    actionUser = ones(nUser,1);
    actionFC = ones(nUser,1);
    
    disp(['Exp:' mat2str(experiment) ' est ' mat2str(estimatorChoice) ' nUser ' mat2str(nUser) ' Str ' dispMessage] )
    %% SGD Initializations
    load('physics_train.mat');
    A = A(randperm(size(A,1)),:);
    % Separate the features and the classes
    Zf = A(:,1:end-1);
    Zc = A(:,end);
    % Set the classes indexes to be {−1,+1}.
    Zc = 2*Zc-1;
    % Remove empty features
    I = find(mean(abs(Zf))>1e-1); 
    Zf = Zf(:,I);
    [nOfSamples,nOfDimensions] = size(Zf);
    % Normalize Zf
    Zf = Zf-repmat(mean(Zf),[size(Zf,1),1]);
    Zf = Zf ./ repmat( sqrt(sum(Zf.^2)/size(Zf,1)), [size(Zf,1),1] );
    % Gradient Function Description
    nablaLL = @(ell)1./(1+exp(-ell));
    nablaFTilde = @(theta,i)-Zc(i)*Zf(i,:)'*nablaLL(-Zc(i)*(Zf(i,:)*theta));
    
    % Objective Function
    L = @(s,Z_y)1/nOfSamples * sum( log( 1 + exp(-s.*Z_y) ) );
    E = @(param,Z_x,Z_y)L(Z_x*param,Z_y);
    
    % Optimization Parameter
    theta = 2*rand(nOfDimensions,1);
    ElistS = zeros(nIter/plotRate,1);
    
    %% Outputs for Analysis
    trueUserCooperationRate = zeros(nIter/plotRate,1);
    phiVectorIteration = zeros(nIter/plotRate,1);
    mNormIteration = zeros(nIter/plotRate,1);
    tempRewardVector = zeros(nIter/plotRate,1);
    tempUserPayoffVector = zeros(nIter/plotRate,1);
    tempTruePositiveRateVector = zeros(nIter/plotRate,1);
    tempFalsePositiveRateVector = zeros(nIter/plotRate,1);
    
    % SVD Mod:
    tempSVD = zeros(nIter/plotRate,46);
    
    %% SGD Iterations
    for t = 1:nIter
        xi = xi0;
        nu = nu0;
        
        X = zeros(nOfDimensions, nUser);
        Y = zeros(nOfDimensions, nUser);
        
        %% User Side
        tempTrueUserCooperationRate = 0;
        dataIndex = 1 + floor(rand(userBatch,nUser)*nOfSamples);
        for k = 1:nUser
            % Stochastic Gradients are Generated
            x_k = zeros(nOfDimensions,1);
            for userDataIndex = 1:userBatch
                x_k = x_k + nablaFTilde(theta,dataIndex(userDataIndex,k));
            end
            X(:,k) = x_k/userBatch;
            % User Actions are generated
            if actionFC(k,1) == 1 %C
                if actionUser(k,1) == 1 %c
                    StrategyUserTemp = UserStr(1);
                else
                    StrategyUserTemp = UserStr(2);
                end
            else
                if actionUser(k,1) == 1
                    StrategyUserTemp = UserStr(3);
                else
                    StrategyUserTemp = UserStr(4);
                end
            end
            actionUser(k,1) = rand < StrategyUserTemp;
            % User Reports are generated
            if actionUser(k,1) == 1
                Y(:,k) = X(:,k) + mvnrnd(zeros(nOfDimensions,1),(nu^2)*eye(nOfDimensions),1)';
                tempTrueUserCooperationRate = tempTrueUserCooperationRate + 1;
            else
                Y(:,k) = mvnrnd(zeros(nOfDimensions,1),(xi^2)*eye(nOfDimensions),1)';
            end
        end
                
        %% FC Joint Gradient Est and Hypothesis Testing
        denom = nUser*lambda*UserStr';
        m_hat = sum(Y,2)/denom;
        mu = zeros(nOfDimensions,1);
        coopUserPrediction = 0;
        truePositive = 0;
        falsePositive = 0;
              
        detThreshold = detThresholdParam + sqrt((2*nOfDimensions*log(xi/nu) - 2*log((1-lambda*UserStr')/(lambda*UserStr')))*(nu^2)*(xi^2)/((xi^2)-(nu^2)));
        for k = 1:nUser
            belief = norm(Y(:,k)) < detThreshold;
            if belief == 1 %c_hat
                mu = mu + Y(:,k);
                coopUserPrediction  = coopUserPrediction + 1;
                if actionUser(k,1) == 1
                    truePositive = truePositive + 1;
                else
                    falsePositive = falsePositive + 1;
                end 
            else
                %mu_d = mu_d + Y(:,k);
            end
        end
        mu = mu/coopUserPrediction;
        %mu_d = mu_d/(nUser-coopUserPrediction);
        
        Phi = chi2cdf((detThreshold/nu)^2,nOfDimensions);
        Psi = chi2cdf((detThreshold/xi)^2,nOfDimensions);
        
        pi1 = (FCStr(1)*(1-Psi) - FCStr(2)*(1-Phi))/(Phi-Psi);
        pi2 = (FCStr(2)*Phi - FCStr(1)*Psi)/(Phi-Psi);
        pi3 = (FCStr(3)*(1-Psi) - FCStr(4)*(1-Phi))/(Phi-Psi);
        pi4 = (FCStr(4)*Phi - FCStr(3)*Psi)/(Phi-Psi);
        

        
        %% FC Actions are Generated
        tempReward = 0;
        for k = 1:nUser
            belief = norm(Y(:,k)) < detThreshold;
            if actionFC(k,1) == 1 %C
                if belief == 1 %c_hat
                    StrategyFCTemp = pi1;
                else
                    StrategyFCTemp = pi2;
                end
            else
                if belief == 1
                    StrategyFCTemp = pi3;
                else
                    StrategyFCTemp = pi4;
                end
            end
            ActionFCTemp = rand < StrategyFCTemp;
            actionFC(k,1) = ActionFCTemp;
            tempReward = tempReward + ActionFCTemp;
        end
        
        if mod(t,plotRate)==1
            %% Temp Modification
            covMatrix = cov(transpose(Y));
%            tempSVD( 1+(t-1)/plotRate,:) = transpose(svd(covMatrix));
 
            ElistS( 1+(t-1)/plotRate,1) = E(theta,Zf,Zc);
            trueUserCooperationRate(1+(t-1)/plotRate,1) = tempTrueUserCooperationRate/nUser;
            expectedUserCooperationRate(1+(t-1)/plotRate,1) = lambda*UserStr';
            phiVectorIteration(1+(t-1)/plotRate,1) = Phi;
            mNormIteration(1+(t-1)/plotRate,1) = norm(m_hat);
            tempRewardVector(1+(t-1)/plotRate,1) = sum(actionFC)/nUser;
            tempUserPayoffVector(1+(t-1)/plotRate,1) = sum(actionFC-0.5*actionUser)/nUser;
            tempTruePositiveRateVector(1+(t-1)/plotRate,1) = truePositive/sum(actionUser);
            tempFalsePositiveRateVector(1+(t-1)/plotRate,1) = falsePositive/(nUser-sum(actionUser));
        end
        
        if stepSizeChoice == 1
            tau = tau0/(1+t/l0);
        else
            tau = 0.01;
        end
        if estimatorChoice == 1
            theta = theta - tau*m_hat;
        else
            theta = theta - tau*mu;
        end
        lambda=(lambda*Omega);
    end
%u = log10(ElistS-0.543121286203416);
%plot(1:plotRate:nIter, u, 'b');
% plot(1:plotRate:nIter,trueUserCooperationRate, 'b')
emptyList = emptyList + ElistS;
averageTrueUserCooperationRate = averageTrueUserCooperationRate + trueUserCooperationRate;
PhiVector = PhiVector + phiVectorIteration;
mNormVector = mNormVector + mNormIteration;
userPayoff = userPayoff + tempUserPayoffVector;
rewardVector = rewardVector + tempRewardVector;
truePositiveRate = tempTruePositiveRateVector + truePositiveRate;
falsePositiveRate = tempFalsePositiveRateVector + falsePositiveRate;
svd_samples = svd_samples + tempSVD;
end

ElistS = emptyList/nOfExperiments;
u = log10(ElistS-0.543121286203416);
figure, plot(1:plotRate:nIter, u, 'b');
title(['log(E(w_l) - min E) q='  mat2str(UserStr)  ' p='  mat2str(FCStr) ]); set(gca, 'FontSize', 10);

averageTrueUserCooperationRate = averageTrueUserCooperationRate/nOfExperiments;
figure, plot(1:plotRate:nIter, averageTrueUserCooperationRate, 'b', 1:plotRate:nIter, expectedUserCooperationRate, 'r');
title(['User Cooperation Probability nu=' mat2str(nu0) ' p=' mat2str(FCStr)]); set(gca, 'FontSize', 10);

PhiVector = PhiVector/nOfExperiments;
figure, plot(1:plotRate:nIter, PhiVector, 'b');
title(['Phi q='  mat2str(UserStr)  ' p=' mat2str(FCStr)]); set(gca, 'FontSize', 10);

mNormVector = mNormVector/nOfExperiments;
figure, plot(1:plotRate:nIter, mNormVector, 'b');
title(['mNorm q='  mat2str(UserStr)  ' p=' mat2str(FCStr)]); set(gca, 'FontSize', 10);

userPayoff = userPayoff/nOfExperiments;
figure, plot(1:plotRate:nIter, userPayoff, 'b');
title(['userPayoff q=' mat2str(UserStr) ' p=' mat2str(FCStr)]); set(gca, 'FontSize', 10);

rewardVector = rewardVector/nOfExperiments;
figure, plot(1:plotRate:nIter, rewardVector, 'b');
title(['Reward Vector q='  mat2str(UserStr)  ' p=' mat2str(FCStr)]); set(gca, 'FontSize', 10);

truePositiveRate = truePositiveRate/nOfExperiments;
figure, plot(1:plotRate:nIter, truePositiveRate, 'b');
title(['True Positive Rate q='  mat2str(UserStr)  ' p=' mat2str(FCStr)]); set(gca, 'FontSize', 10);

falsePositiveRate = falsePositiveRate/nOfExperiments;
figure, plot(1:plotRate:nIter, falsePositiveRate, 'b');
title(['False Positive Rate q='  mat2str(UserStr)  ' p=' mat2str(FCStr)]); set(gca, 'FontSize', 10);

out = u;
out2 = truePositiveRate;
out3 = falsePositiveRate;
out4 = averageTrueUserCooperationRate;
out5 = mNormVector;
out6 = rewardVector;
out7 = userPayoff;