import os
import numpy as np
from skimage.transform import resize
from PIL import Image
import tensorflow as tf
from numpy import asarray

'''Splits MNIST dataset into distinct subfolders according to their classes.'''


def scale_images(images, new_shape):
    images_list = list()
    for image in images:
        # resize with nearest neighbor interpolation
        new_image = resize(image, new_shape, 0)
        # store
        images_list.append(new_image)
    return asarray(images_list)


def MNIST_split():
    all_directory = 'MNIST_all_data'
    if not os.path.exists(all_directory):
        os.mkdir(all_directory)
    mnist = tf.keras.datasets.mnist
    (x_train, y_train), (x_test, y_test) = mnist.load_data()
    print('Scaling images... This may take a moment...')
    x_train = 255 * scale_images(x_train, (28, 28))
    x_train = x_train.astype(np.uint8)
    x_test = 255 * scale_images(x_test, (28, 28))
    x_test = x_test.astype(np.uint8)
    print('Images are scaled.')
    for index in range(len(x_train)):
        image_name = all_directory + '/Label_' + str(index) + '_' + str(y_train[index]) + '_.png'
        im = Image.fromarray(x_train[index, :, :])
        im.save(image_name)
    print('All images are saved under the same folder.')


if __name__ == '__main__':
    MNIST_split()
